Bug 216703

Summary: Regression(r265280) Web Audio sources malfunction when disconnected from the audio graph
Product: WebKit Reporter: Justin Uberti <juberti>
Component: Web AudioAssignee: youenn fablet <youennf>
Status: RESOLVED FIXED    
Severity: Normal CC: cdumez, eric.carlson, ews-watchlist, glenn, jer.noble, philipj, sergio, webkit-bug-importer, youennf
Priority: P2 Keywords: InRadar
Version: Safari Technology Preview   
Hardware: All   
OS: Other   
Bug Depends on:    
Bug Blocks: 212611, 215127    
Attachments:
Description Flags
Patch none

Description Justin Uberti 2020-09-18 10:05:48 PDT
Observed in STP 113 and iOS14 GA. Does not occur in Chrome or Safari 13.

When using a Web Audio graph of the form:

(BufferSource) -> (MediaStreamDestination) -> (HTMLMediaElement)

disconnecting the BufferSource from the graph causes a malfunction, and garbage audio to be fed to the HTMLMediaElement. Setting HTMLMediaElement.srcObject = null works around the issue.

Demo: https://jsfiddle.net/juberti/dev32of4/
Comment 1 Radar WebKit Bug Importer 2020-09-18 10:08:12 PDT
<rdar://problem/69158436>
Comment 2 Chris Dumez 2020-09-23 16:05:03 PDT
I am able to reproduce. Thank you for the reproduction case, I will investigate.
Comment 3 Chris Dumez 2020-09-23 16:26:52 PDT
This is a regression from http://trac.webkit.org/changeset/265280.
Comment 4 youenn fablet 2020-09-24 02:22:37 PDT
Created attachment 409546 [details]
Patch
Comment 5 EWS 2020-09-24 08:11:35 PDT
Committed r267530: <https://trac.webkit.org/changeset/267530>

All reviewed patches have been landed. Closing bug and clearing flags on attachment 409546 [details].